<template>
   <el-form ref="pwdRef" :model="user" :rules="rules" label-width="80px">
      <div style="color:red;font-size: 13px;width: 100%;text-align: right;">
          *密码为8位及以上且必须包含大小写字母+特殊字符+数字相结合
      </div>
      <el-form-item label="旧密码" prop="oldPassword">
         <el-input v-model="user.oldPassword" placeholder="请输入旧密码" type="password" show-password />
      </el-form-item>
      <el-form-item label="新密码" prop="newPassword">
         <el-input v-model="user.newPassword" placeholder="请输入新密码" type="password" show-password />
      </el-form-item>
      <el-form-item label="确认密码" prop="confirmPassword">
         <el-input v-model="user.confirmPassword" placeholder="请确认新密码" type="password" show-password/>
      </el-form-item>
      <el-form-item>
      <el-button type="primary" @click="submit">保存</el-button>
      <el-button type="danger" @click="close">关闭</el-button>
      </el-form-item>
   </el-form>
</template>

<script setup>
import { updateUserPwd } from "@/api/system/user"
import { encryptAES, decryptAES } from '@/utils/cryptoAES'
import { getIsKey } from '@/utils/crypto'
import useUserStore from '@/store/modules/user'

const { proxy } = getCurrentInstance()

const user = reactive({
  oldPassword: undefined,
  newPassword: undefined,
  confirmPassword: undefined
})

const equalToPassword = (rule, value, callback) => {
  if (user.newPassword !== value) {
    callback(new Error("两次输入的密码不一致"))
  } else {
    callback()
  }
}

const rules = ref({
  oldPassword: [{ required: true, message: "旧密码不能为空", trigger: "blur" }],
  newPassword: [{ required: true, message: "新密码不能为空", trigger: "blur" }
  , { validator: validatePassword, trigger: "blur" }],
  confirmPassword: [{ required: true, message: "确认密码不能为空", trigger: "blur" }
  , { required: true, validator: equalToPassword, trigger: "blur" }]
})

/** 提交按钮 */
function submit() {
  proxy.$refs.pwdRef.validate(async valid => {
    if (valid) {
      let requestForm = {...user}
      try {
        const keyObj = await getIsKey()
        const isKey = keyObj["data"];
        if("1" === isKey || 1 === isKey){
          requestForm.oldPassword = encryptAES(user.oldPassword)
          requestForm.newPassword = encryptAES(user.newPassword)
        }
      } catch (error) {}
      updateUserPwd(requestForm.oldPassword, requestForm.newPassword).then(response => {
        proxy.$modal.msgSuccess("修改成功")
        setTimeout(() => {
          const userStore = useUserStore()
          userStore.logOut().then(() => {
            location.href = '/index'
          })
        }, 1000)
      })
    }
  })
}

function validatePassword(rule, value, callback) {
  if (checkPassword(value) === false) {
    callback(new Error("密码格式不符合要求"))
  } else {
    callback()
  }
}

function checkPassword(password) {
    // 基础长度检查
    if (!password || password.length < 8) {
        return false;
    }
    // 正则表达式验证
    const regex = /^(?=.*[a-z])(?=.*[A-Z])(?=.*\d)(?=.*[!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?])[A-Za-z\d!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?]{8,}$/;
    return regex.test(password);
}

/** 关闭按钮 */
function close() {
  proxy.$tab.closePage()
}
</script>
